# t20010 - Container sequence diagram test case
## Config
```yaml
diagrams:
  t20010_sequence:
    type: sequence
    glob:
      - t20010.cc
    include:
      namespaces:
        - clanguml::t20010
    using_namespace: clanguml::t20010
    from:
      - function: "clanguml::t20010::tmain()"
```
## Source code
File `tests/t20010/t20010.cc`
```cpp
#include <array>
#include <map>
#include <memory>
#include <vector>

namespace clanguml {
namespace t20010 {

struct A {
    void a1() { }
    void a2() { }
    void a3() { }
    void a4() { }
};

template <typename T> struct B {
    void b1() { a_.a1(); }
    void b2() { avector_.front().a2(); }
    void b3() { aptrvector_.front()->a3(); }
    void b4() { amap_.at(0).a4(); }

    A a_;
    std::vector<A> avector_;
    std::vector<std::unique_ptr<A>> aptrvector_;
    std::map<T, A> amap_;
};

void tmain()
{
    B<int> b;

    b.b1();
    b.b2();
    b.b3();
    b.b4();
}

}
}
```
## Generated PlantUML diagrams
![t20010_sequence](./t20010_sequence.svg "Container sequence diagram test case")
## Generated Mermaid diagrams
![t20010_sequence](./t20010_sequence_mermaid.svg "Container sequence diagram test case")
## Generated JSON models
```json
{
  "diagram_type": "sequence",
  "name": "t20010_sequence",
  "participants": [
    {
      "display_name": "tmain()",
      "id": "1364660609791735244",
      "name": "tmain",
      "namespace": "clanguml::t20010",
      "source_location": {
        "column": 6,
        "file": "t20010.cc",
        "line": 28,
        "translation_unit": "t20010.cc"
      },
      "type": "function"
    },
    {
      "activities": [
        {
          "display_name": "b1()",
          "id": "343626060927491836",
          "name": "b1",
          "namespace": "",
          "source_location": {
            "column": 10,
            "file": "t20010.cc",
            "line": 17,
            "translation_unit": "t20010.cc"
          },
          "type": "method"
        },
        {
          "display_name": "b2()",
          "id": "1633031113603062043",
          "name": "b2",
          "namespace": "",
          "source_location": {
            "column": 10,
            "file": "t20010.cc",
            "line": 18,
            "translation_unit": "t20010.cc"
          },
          "type": "method"
        },
        {
          "display_name": "b3()",
          "id": "786218543654309692",
          "name": "b3",
          "namespace": "",
          "source_location": {
            "column": 10,
            "file": "t20010.cc",
            "line": 19,
            "translation_unit": "t20010.cc"
          },
          "type": "method"
        },
        {
          "display_name": "b4()",
          "id": "1866068965397702666",
          "name": "b4",
          "namespace": "",
          "source_location": {
            "column": 10,
            "file": "t20010.cc",
            "line": 20,
            "translation_unit": "t20010.cc"
          },
          "type": "method"
        }
      ],
      "display_name": "B<int>",
      "id": "2154977200904210115",
      "name": "B",
      "namespace": "clanguml::t20010",
      "source_location": {
        "column": 30,
        "file": "t20010.cc",
        "line": 16,
        "translation_unit": "t20010.cc"
      },
      "type": "class"
    },
    {
      "activities": [
        {
          "display_name": "a1()",
          "id": "981184681827469850",
          "name": "a1",
          "namespace": "",
          "source_location": {
            "column": 10,
            "file": "t20010.cc",
            "line": 10,
            "translation_unit": "t20010.cc"
          },
          "type": "method"
        },
        {
          "display_name": "a2()",
          "id": "664370880632146592",
          "name": "a2",
          "namespace": "",
          "source_location": {
            "column": 10,
            "file": "t20010.cc",
            "line": 11,
            "translation_unit": "t20010.cc"
          },
          "type": "method"
        },
        {
          "display_name": "a3()",
          "id": "2145739294823015899",
          "name": "a3",
          "namespace": "",
          "source_location": {
            "column": 10,
            "file": "t20010.cc",
            "line": 12,
            "translation_unit": "t20010.cc"
          },
          "type": "method"
        },
        {
          "display_name": "a4()",
          "id": "1224936485834400821",
          "name": "a4",
          "namespace": "",
          "source_location": {
            "column": 10,
            "file": "t20010.cc",
            "line": 13,
            "translation_unit": "t20010.cc"
          },
          "type": "method"
        }
      ],
      "display_name": "A",
      "id": "102070351492425113",
      "name": "A",
      "namespace": "clanguml::t20010",
      "source_location": {
        "column": 8,
        "file": "t20010.cc",
        "line": 9,
        "translation_unit": "t20010.cc"
      },
      "type": "class"
    }
  ],
  "sequences": [
    {
      "messages": [
        {
          "from": {
            "activity_id": "1364660609791735244",
            "participant_id": "1364660609791735244"
          },
          "name": "b1()",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 5,
            "file": "t20010.cc",
            "line": 32,
            "translation_unit": "t20010.cc"
          },
          "to": {
            "activity_id": "343626060927491836",
            "participant_id": "2154977200904210115"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "343626060927491836",
            "participant_id": "2154977200904210115"
          },
          "name": "a1()",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 17,
            "file": "t20010.cc",
            "line": 17,
            "translation_unit": "t20010.cc"
          },
          "to": {
            "activity_id": "981184681827469850",
            "participant_id": "102070351492425113"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "1364660609791735244",
            "participant_id": "1364660609791735244"
          },
          "name": "b2()",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 5,
            "file": "t20010.cc",
            "line": 33,
            "translation_unit": "t20010.cc"
          },
          "to": {
            "activity_id": "1633031113603062043",
            "participant_id": "2154977200904210115"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "1633031113603062043",
            "participant_id": "2154977200904210115"
          },
          "name": "a2()",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 17,
            "file": "t20010.cc",
            "line": 18,
            "translation_unit": "t20010.cc"
          },
          "to": {
            "activity_id": "664370880632146592",
            "participant_id": "102070351492425113"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "1364660609791735244",
            "participant_id": "1364660609791735244"
          },
          "name": "b3()",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 5,
            "file": "t20010.cc",
            "line": 34,
            "translation_unit": "t20010.cc"
          },
          "to": {
            "activity_id": "786218543654309692",
            "participant_id": "2154977200904210115"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "786218543654309692",
            "participant_id": "2154977200904210115"
          },
          "name": "a3()",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 17,
            "file": "t20010.cc",
            "line": 19,
            "translation_unit": "t20010.cc"
          },
          "to": {
            "activity_id": "2145739294823015899",
            "participant_id": "102070351492425113"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "1364660609791735244",
            "participant_id": "1364660609791735244"
          },
          "name": "b4()",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 5,
            "file": "t20010.cc",
            "line": 35,
            "translation_unit": "t20010.cc"
          },
          "to": {
            "activity_id": "1866068965397702666",
            "participant_id": "2154977200904210115"
          },
          "type": "message"
        },
        {
          "from": {
            "activity_id": "1866068965397702666",
            "participant_id": "2154977200904210115"
          },
          "name": "a4()",
          "return_type": "void",
          "scope": "normal",
          "source_location": {
            "column": 17,
            "file": "t20010.cc",
            "line": 20,
            "translation_unit": "t20010.cc"
          },
          "to": {
            "activity_id": "1224936485834400821",
            "participant_id": "102070351492425113"
          },
          "type": "message"
        }
      ],
      "start_from": {
        "id": 1364660609791735244,
        "location": "clanguml::t20010::tmain()"
      }
    }
  ],
  "using_namespace": "clanguml::t20010"
}
```
