# t20023 - Try/catch statement sequence diagram test case
## Config
```yaml
diagrams:
  t20023_sequence:
    type: sequence
    glob:
      - t20023.cc
    include:
      namespaces:
        - clanguml::t20023
    using_namespace: clanguml::t20023
    from:
      - function: "clanguml::t20023::tmain()"
```
## Source code
File `tests/t20023/t20023.cc`
```cpp
#include <stdexcept>

namespace clanguml {
namespace t20023 {

struct A {
    int a1() { return 1; }
    int a2() { return 2; }
    int a3() { return 3; }
    int a4() { return 3; }

    int a()
    {
        try {
            return a1();
        }
        catch (std::runtime_error &) {
            return a2();
        }
        catch (std::logic_error &) {
            return a3();
        }
        catch (...) {
            return a4();
        }
    }
};

int tmain()
{
    A a;

    int result{};

    result = a.a();

    return result;
}
}
}
```
## Generated PlantUML diagrams
![t20023_sequence](./t20023_sequence.svg "Try/catch statement sequence diagram test case")
## Generated Mermaid diagrams
![t20023_sequence](./t20023_sequence_mermaid.svg "Try/catch statement sequence diagram test case")
## Generated JSON models
```json
{
  "diagram_type": "sequence",
  "name": "t20023_sequence",
  "participants": [
    {
      "display_name": "tmain()",
      "id": "761552264135157511",
      "name": "tmain",
      "namespace": "clanguml::t20023",
      "source_location": {
        "column": 5,
        "file": "t20023.cc",
        "line": 29,
        "translation_unit": "t20023.cc"
      },
      "type": "function"
    },
    {
      "activities": [
        {
          "display_name": "a()",
          "id": "530651320277188697",
          "name": "a",
          "namespace": "",
          "source_location": {
            "column": 9,
            "file": "t20023.cc",
            "line": 12,
            "translation_unit": "t20023.cc"
          },
          "type": "method"
        },
        {
          "display_name": "a1()",
          "id": "94135113932519208",
          "name": "a1",
          "namespace": "",
          "source_location": {
            "column": 9,
            "file": "t20023.cc",
            "line": 7,
            "translation_unit": "t20023.cc"
          },
          "type": "method"
        },
        {
          "display_name": "a2()",
          "id": "2060438178899014465",
          "name": "a2",
          "namespace": "",
          "source_location": {
            "column": 9,
            "file": "t20023.cc",
            "line": 8,
            "translation_unit": "t20023.cc"
          },
          "type": "method"
        },
        {
          "display_name": "a3()",
          "id": "1776927259621603017",
          "name": "a3",
          "namespace": "",
          "source_location": {
            "column": 9,
            "file": "t20023.cc",
            "line": 9,
            "translation_unit": "t20023.cc"
          },
          "type": "method"
        },
        {
          "display_name": "a4()",
          "id": "1082587698374248813",
          "name": "a4",
          "namespace": "",
          "source_location": {
            "column": 9,
            "file": "t20023.cc",
            "line": 10,
            "translation_unit": "t20023.cc"
          },
          "type": "method"
        }
      ],
      "display_name": "A",
      "id": "750638294800359616",
      "name": "A",
      "namespace": "clanguml::t20023",
      "source_location": {
        "column": 8,
        "file": "t20023.cc",
        "line": 6,
        "translation_unit": "t20023.cc"
      },
      "type": "class"
    }
  ],
  "sequences": [
    {
      "messages": [
        {
          "from": {
            "activity_id": "761552264135157511",
            "participant_id": "761552264135157511"
          },
          "name": "a()",
          "return_type": "int",
          "scope": "normal",
          "source_location": {
            "column": 14,
            "file": "t20023.cc",
            "line": 35,
            "translation_unit": "t20023.cc"
          },
          "to": {
            "activity_id": "530651320277188697",
            "participant_id": "750638294800359616"
          },
          "type": "message"
        },
        {
          "activity_id": "530651320277188697",
          "branches": [
            {
              "messages": [
                {
                  "from": {
                    "activity_id": "530651320277188697",
                    "participant_id": "750638294800359616"
                  },
                  "name": "a1()",
                  "return_type": "int",
                  "scope": "normal",
                  "source_location": {
                    "column": 20,
                    "file": "t20023.cc",
                    "line": 15,
                    "translation_unit": "t20023.cc"
                  },
                  "to": {
                    "activity_id": "94135113932519208",
                    "participant_id": "750638294800359616"
                  },
                  "type": "message"
                }
              ],
              "type": "main"
            },
            {
              "messages": [
                {
                  "from": {
                    "activity_id": "530651320277188697",
                    "participant_id": "750638294800359616"
                  },
                  "name": "a2()",
                  "return_type": "int",
                  "scope": "normal",
                  "source_location": {
                    "column": 20,
                    "file": "t20023.cc",
                    "line": 18,
                    "translation_unit": "t20023.cc"
                  },
                  "to": {
                    "activity_id": "2060438178899014465",
                    "participant_id": "750638294800359616"
                  },
                  "type": "message"
                }
              ],
              "type": "catch"
            },
            {
              "messages": [
                {
                  "from": {
                    "activity_id": "530651320277188697",
                    "participant_id": "750638294800359616"
                  },
                  "name": "a3()",
                  "return_type": "int",
                  "scope": "normal",
                  "source_location": {
                    "column": 20,
                    "file": "t20023.cc",
                    "line": 21,
                    "translation_unit": "t20023.cc"
                  },
                  "to": {
                    "activity_id": "1776927259621603017",
                    "participant_id": "750638294800359616"
                  },
                  "type": "message"
                }
              ],
              "type": "catch"
            },
            {
              "messages": [
                {
                  "from": {
                    "activity_id": "530651320277188697",
                    "participant_id": "750638294800359616"
                  },
                  "name": "a4()",
                  "return_type": "int",
                  "scope": "normal",
                  "source_location": {
                    "column": 20,
                    "file": "t20023.cc",
                    "line": 24,
                    "translation_unit": "t20023.cc"
                  },
                  "to": {
                    "activity_id": "1082587698374248813",
                    "participant_id": "750638294800359616"
                  },
                  "type": "message"
                }
              ],
              "type": "catch"
            }
          ],
          "name": "try",
          "type": "break"
        }
      ],
      "start_from": {
        "id": 761552264135157511,
        "location": "clanguml::t20023::tmain()"
      }
    }
  ],
  "using_namespace": "clanguml::t20023"
}
```
